#!/bin/sh
#menus.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 David Lucardi <davidlucardi@aol.com>
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
#  Copyright (C) 2003 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: path.tcl,v 1.9 2006/04/22 06:33:38 david Exp $
#  Author  : davidlucardi@aol.com
#  Modifier: 
#  Date    : 
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     David Lucardi
#  @modifier   
#  @project    Le terrier
#  @copyright  David Lucardi, Andr Connes, Eric Seigne
# 
#  *************************************************************************
proc setwindowsusername {} {
    global user LogHome
    catch {destroy .utilisateur}
    toplevel .utilisateur -background grey -width 250 -height 100
    wm geometry .utilisateur +50+50
    frame .utilisateur.frame -background grey -width 250 -height 100
    pack .utilisateur.frame -side top
    label .utilisateur.frame.labobj -font {Helvetica 10} -text [mc {Quel est ton nom?}] -background grey
    pack .utilisateur.frame.labobj -side top 

    listbox .utilisateur.frame.listsce -yscrollcommand ".utilisateur.frame.scrollpage set" -width 15 -height 10
    scrollbar .utilisateur.frame.scrollpage -command ".utilisateur.frame.listsce yview" -width 7
    pack .utilisateur.frame.listsce .utilisateur.frame.scrollpage -side left -fill y -expand 1 -pady 10
    bind .utilisateur.frame.listsce <ButtonRelease-1> "verifnom %x %y"
    foreach i [lsort [glob [file join $LogHome *.log]]] {
    .utilisateur.frame.listsce insert end [string map {.log \040} [file tail $i]]
    }

    button .utilisateur.frame.ok -background gray75 -text [mc {Ok}] -command "interface; destroy .utilisateur"
    pack .utilisateur.frame.ok -side top -pady 70 -padx 10
}

proc verifnom {x y} {
    global env user LogHome

set ind [.utilisateur.frame.listsce index @$x,$y]
set nom [string trim [.utilisateur.frame.listsce get $ind]]
    if {$nom !=""} {
	set env(USERNAME) $nom
	set user [file join $LogHome $nom.log]
    }
}

proc init {plateforme} {
    global Home basedir baseHome
    
    
    if {![file exists [file join $Home]]} {
	file mkdir [file join $Home]
	file copy -force [file join reglages] [file join $Home]
	file copy -force [file join textes] [file join $Home]
    }
    
    switch $plateforme {
	unix {
	    if {![file exists [file join $baseHome log]]} {
		file mkdir [file join $baseHome log]
	    }
	    
	}
	windows {
	    if {![file exists [file join aller log]]} {
		file mkdir [file join aller log]
	    }
	    
    	}
    }
    
}


proc initlog {plateforme ident} {
global LogHome user Home baseHome
    switch $plateforme {
	unix {
	    set LogHome [file join $baseHome log]
	    
	}
	windows {
	    set LogHome [file join aller log]
	}
    }
    
    if {$ident != ""} {
	set user [file join $LogHome $ident.log]
    } else {
	set user [file join $LogHome aller.log]
    }
if {![file exists [file join $user]]} {
set f [open [file join $user] "w"]
close $f
}
}

proc inithome {} {
    global baseHome basedir Homeconf Home
    variable reperttext
    variable repertconf
    variable demarre
    variable defauttext
    set f [open [file join $baseHome reglages aller.conf] "r"]
    set demarre [gets $f]
    set defauttext [gets $f]
    close $f

    set f [open [file join $baseHome reglages repert.conf] "r"]
    set reperttext [gets $f]
    set repertconf [gets $f]
    close $f
    #on synchronise les 2 variables en attendant
    
    switch $repertconf {
	0 {set Home [file join $baseHome]}
	1 {set Home [file join $basedir]}
    }
    switch $repertconf {
	0 {set Homeconf $baseHome}
	1 {set Homeconf $basedir}
    }
    
}


proc changehome {} {
    global Home basedir baseHome Homeconf
    variable reperttext
    variable repertconf
    variable defauttext
    variable demarre
    set f [open [file join $baseHome reglages aller.conf] "r"]
    set demarre [gets $f]
    set defauttext [gets $f]
    close $f

    set f [open [file join $baseHome reglages repert.conf] "w"]
    #on synchronise les 2 variables en attendant
    puts $f $repertconf
    puts $f $repertconf
    close $f
    switch $repertconf {
	0 {set Home $baseHome}
	1 {set Home $basedir}
    }
    switch $repertconf {
	0 {set Homeconf $baseHome}
	1 {set Homeconf $basedir}
    }
}

global basedir Home baseHome iwish Homeconf progaide  listexo disabledfore disabledback abuledu prof

set abuledu 0
set prof 0

	if {[info tclversion] == "8.4"} {
    	set disabledfore disabledforeground
      set disabledback disabledbackground
	} else {
	set disabledfore fg
      set disabledback bg
	}

set basedir [file dir $argv0]
cd $basedir
if {$env(HOME) == "c:\\"} {
    set Home [file join $basedir]
    set Homeconf [file join $basedir]
    
} else {
    set Home [file join $env(HOME) leterrier aller]
    set Homeconf [file join $env(HOME) leterrier aller]
}
set baseHome $Home

set listexo {{closure Closure Complte 1 1} {reconstitution Reconstitution Complte 1 1} {phrase {Phrases mlanges} {Clique sur une phrase et dplace-l en cliquant sur les flches} 1 1} {mot {Mots mlangs} {Remets les mots dans l'ordre sur les traits roses} 1 1} {faute {Texte  corriger} {Clique sur les mots mal crits, rcris-les et appuie sur entre.} 1 1} {espace {Phrases sans espaces} {Clique pour sparer les mots} 1 1} {incomplet {Phrases incompltes} {Complte} 1 1} {{Exercice supplmentaire} {Exercice supplmentaire 1} {Exercice 1} 1 0} {{Exercice supplmentaire} {Exercice supplmentaire 2} {Exercice 2} 1 0} {{Exercice supplmentaire} {Exercice supplmentaire 3} {Exercice 3} 1 0} {{Exercice supplmentaire} {Exercice supplmentaire 4} {Exercice 4} 1 0} {ponctuation1 Ponctuation1 {Complte avec le signe convenable} 1 1} {ponctuation2 Ponctuation2 {Clique pour rtablir la ponctuation et complte avec le signe convenable} 1 1}}


switch $tcl_platform(platform) {
    unix {
	set progaide runbrowser
    if {[lsearch [exec id -nG $env(USER)] "profs"] != -1} {set prof 1}
	#if {[file isdirectory [file join /etc abuledu]]} {set abuledu 1}
	set abuledu 1
	set iwish wish
    }
    windows {
	set progaide shellexec.exe
	set iwish wish
    }
}


