############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : $$$
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#reglages.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

#source msg.tcl
global sysFont Home Homeconf exo strtext listexo repert
catch {destroy .w1}
toplevel .w1
set basedir [file dir $argv0]
cd $basedir

set exo none
wm title .w1 [mc {Reglages}]
.w1 configure -background Steelblue2
set font $sysFont(l)

frame .w1.frametop1 -width 132 -background Steelblue2
grid .w1.frametop1 -row 0 -column 0
label .w1.frametop1.labeltop1 -text [mc {Choix de l'exercice}] -background Steelblue2
grid .w1.frametop1.labeltop1 -column 0 -row 0
frame .w1.frametop2 -width 360
grid .w1.frametop2 -row 0 -column 1
label .w1.frametop2.labeltop2 -text [mc {Parametrages}] -background Steelblue2
grid .w1.frametop2.labeltop2 -column 0 -row 0
#frame .w1.frametop3  -width 180
#grid .w1.frametop3 -row 0 -column 2
#label .w1.frametop3.labeltop3 -text [mc {Choix du texte}] -background Steelblue2
#grid .w1.frametop3.labeltop3 -column 0 -row 0

frame .w1.frameleft -height 280 -width 160 
grid .w1.frameleft -column 0 -row 1

set i 0
    foreach menu {Closure Reconstitution {Phrases melangees} {Mots melanges} {Texte a corriger} {Phrases sans espaces} {Phrases incompletes} {Exercice 1} {Exercice 2} {Exercice 3} {Exercice 4} Ponctuation} {
    label .w1.frameleft.l$i -text [mc $menu] -width 26 -font $sysFont(sb)
    place .w1.frameleft.l$i -x 0 -y [expr 20*$i]
    bind .w1.frameleft.l$i <Any-Enter> "pushEnter $i"
    bind .w1.frameleft.l$i <Any-Leave> "pushLeave $i"
    bind .w1.frameleft.l$i <ButtonRelease-1> "select $i"
    incr i
    }
frame .w1.frame1 -background Steelblue2 -height 280 -width 360
grid .w1.frame1 -column 1 -row 1

###########################################################
proc select {i} {
global sysFont exo
set list {closure reconstitution phrase mot faute espace incomplet bisque1 bisque2 bisque3 bisque4 ponctuation}
    for {set k 0} {$k < 12} {incr k 1} {
    .w1.frameleft.l$k configure -background grey
    }
.w1.frameleft.l$i configure -background Steelblue2
set exo [lindex $list $i]
interfac [lindex $list $i]
}
##############################################################

proc pushEnter {i} {
.w1.frameleft.l$i configure -cursor hand2
}

##########################################################
proc pushLeave {i} {
.w1.frameleft.l$i configure -cursor left_ptr
}

##########################################################"""

proc chargedonnes {exo} {
global sysFont listexo Home Homeconf
set ext .conf
catch {
set f [open [file join $Homeconf reglages $exo$ext] "r"]
set aller [gets $f]
close $f
}
    switch $exo {
    closure {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 2] == 0} {
            .w1.frame1.sel5 deselect
            }
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    reconstitution {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 2] == 0} {
            .w1.frame1.sel5 deselect
            }
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    mot {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    phrase {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    faute {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    espace {
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    incomplet {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }
      bisque1 {

            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 2] == 0} {
            .w1.frame1.sel5 deselect
            }
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

      bisque2 {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 2] == 0} {
            .w1.frame1.sel5 deselect
            }
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }
      bisque3 {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 2] == 0} {
            .w1.frame1.sel5 deselect
            }
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }
      bisque4 {
            .w1.frame1.sel[lindex $aller 0] select
            if {[lindex $aller 2] == 0} {
            .w1.frame1.sel5 deselect
            }
            if {[lindex $aller 1] == 0} {
            .w1.frame1.sel4 deselect
            }
            if {[lindex $aller 4] == 0} {
            .w1.frame1.sel6 deselect
            }
        }

    }

}

########################################################""




proc interfac {exo} {
global sysFont listexo

catch {destroy .w1.frame1}
frame .w1.frame1 -background Steelblue2 -height 280 -width 360
grid .w1.frame1 -column 1 -row 1
bind .w1.frame1 <Destroy> "enregistre $exo"
                        
switch $exo {
    closure {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel5 -text [mc {La liste d'aide est variable}] -variable sel5 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel5 -x 40 -y 180
            .w1.frame1.sel5 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }
    reconstitution {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel5 -text [mc {La liste d'aide est variable}] -variable sel5 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel5 -x 40 -y 180
            .w1.frame1.sel5 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }
    mot {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }

    phrase {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            }
    faute {
            label .w1.frame1.menu1 -text [mc {Reponse :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel6 -text [mc {Les marques de textes sont visibles.}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            }
    espace {
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            }

    incomplet {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            }
    bisque1  {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel5 -text [mc {La liste d'aide est variable}] -variable sel5 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel5 -x 40 -y 180
            .w1.frame1.sel5 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }

    bisque2  {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel5 -text [mc {La liste d'aide est variable}] -variable sel5 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel5 -x 40 -y 180
            .w1.frame1.sel5 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }
      bisque3 {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel5 -text [mc {La liste d'aide est variable}] -variable sel5 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel5 -x 40 -y 180
            .w1.frame1.sel5 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }
       bisque4 {
            label .w1.frame1.menu1 -text [mc {L'aide doit apparaitre :}] -background Steelblue2
            place .w1.frame1.menu1 -x 40 -y 60
            radiobutton .w1.frame1.sel1 -text [mc {Des le debut}] -variable sel1 -relief flat -value 1 -background Steelblue2
            place .w1.frame1.sel1 -x 180 -y 60
            radiobutton .w1.frame1.sel2 -text [mc {Apres le premier essai}] -variable sel1 -relief flat -value 2 -background Steelblue2
            place .w1.frame1.sel2 -x 180 -y 80
            radiobutton .w1.frame1.sel3 -text [mc {Apres le deuxieme essai}] -variable sel1 -relief flat -value 3 -background Steelblue2
            place .w1.frame1.sel3 -x 180 -y 100
            .w1.frame1.sel3 select
            checkbutton .w1.frame1.sel5 -text [mc {La liste d'aide est variable}] -variable sel5 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel5 -x 40 -y 180
            .w1.frame1.sel5 select
            checkbutton .w1.frame1.sel6 -text [mc {Le texte est visible au debut}] -variable sel6 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel6 -x 40 -y 20
            .w1.frame1.sel6 select
            checkbutton .w1.frame1.sel4 -text [mc {Les champs de texte sont de longueur fixe}] -variable sel4 -relief flat -background Steelblue2 -activebackground grey
            place .w1.frame1.sel4 -x 40 -y 160
            .w1.frame1.sel4 select
            }

    }
chargedonnes $exo
}
##################################################################################"


#frame .w1.frame2 -height 280 -width 180
#grid .w1.frame2 -column 2 -row 1

#    label .w1.frame2.titre -text [mc {Fichier a ouvrir :}]
 #   place .w1.frame2.titre -x 5 -y 5

#    label .w1.frame2.categorie -text [mc {Aucun}] -justify left
#    place .w1.frame2.categorie -x 5 -y 20
#    button .w1.frame2.btnrepertoire -text [mc {Choisir un fichier}] -command changerep
#    place .w1.frame2.btnrepertoire -x 40 -y 120
    button .w1.frameleft.ok -text [mc {Ok}] -command "destroy .w1"
    place .w1.frameleft.ok -x 65 -y 250


set categorie ""
#set strtext ""
#set f [open [file join $Homeconf reglages aller.conf] "r"]
#set categorie [gets $f]
#close $f

##########################################modif
# if {[file tail $categorie] != "none" && $categorie != "" && $categorie !=[mc {Aucun}]} {
# .w1.frame2.categorie configure -wraplength 170 -height 4 -text $categorie
#set repert [file dir $categorie]
#   catch { 
#   set f [open $categorie]
#   while {![eof $f]} {
#   set strtext $strtext[read $f 10000]
#   close $f
#   }
# }
#}
############################################################################"
#set listexo {}
#setlistexo $categorie

#if {[string first "\$t tag add bisque1" $strtext]!=-1} {
#.w1.frameleft.l7 configure -text [lindex [lindex $listexo 0] 1]
#}
#if {[string first "\$t tag add bisque2" $strtext]!=-1} {
#.w1.frameleft.l8 configure -text [lindex [lindex $listexo 1] 1]
#}
#if {[string first "\$t tag add bisque3" $strtext]!=-1} {
#.w1.frameleft.l9 configure -text [lindex [lindex $listexo 2] 1]
#}
#if {[string first "\$t tag add bisque4" $strtext]!=-1} {
#.w1.frameleft.l10 configure -text [lindex [lindex $listexo 3] 1]
#}


bind .w1 <Destroy> "enregistre $exo"

############################################################################################

proc enregistre {exo} {
global sysFont categorie Home Homeconf

if {$exo == "none"} {
return}
    switch $exo {
    closure {
             variable sel1
             variable sel4
             variable sel5
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller $sel5
             lappend aller $categorie
             lappend aller $sel6
            }

    reconstitution {
             variable sel1
             variable sel4
             variable sel5
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller $sel5
             lappend aller $categorie
             lappend aller $sel6
            }

    mot      {
             variable sel1
             variable sel4
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller 0
             lappend aller $categorie
             lappend aller $sel6
            }

    phrase {
             variable sel1
             variable sel6
             lappend aller $sel1
             lappend aller 0
             lappend aller 0
             lappend aller $categorie
             lappend aller $sel6
            }

    faute {
             variable sel1
            
             variable sel6
             lappend aller $sel1
             lappend aller 0
             lappend aller 0
             lappend aller $categorie
             lappend aller $sel6
            }

    espace {
             variable sel6
             lappend aller 0
             lappend aller 0
             lappend aller 0
             lappend aller $categorie
             lappend aller $sel6
            }

    incomplet {
             variable sel1
             variable sel6
             lappend aller $sel1
             lappend aller 0
             lappend aller 0
             lappend aller $categorie
             lappend aller $sel6
            }

    ponctuation {
             lappend aller 0
             lappend aller 0
             lappend aller 0
             lappend aller $categorie
             lappend aller 0
            }

        bisque1 {
             variable sel1
             variable sel4
             variable sel5
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller $sel5
             lappend aller $categorie
             lappend aller $sel6
            }

       bisque2 {
             variable sel1
             variable sel4
             variable sel5
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller $sel5
             lappend aller $categorie
             lappend aller $sel6
            }

       bisque3 {
             variable sel1
             variable sel4
             variable sel5
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller $sel5
             lappend aller $categorie
             lappend aller $sel6
            }

       bisque4 {
             variable sel1
             variable sel4
             variable sel5
             variable sel6
             lappend aller $sel1
             lappend aller $sel4
             lappend aller $sel5
             lappend aller $categorie
             lappend aller $sel6
            }

    }
set ext .conf
set f [open [file join $Homeconf reglages $exo$ext] "w"]
puts $f $aller
close $f
}


proc changerep {} {
global categorie Home Homeconf strtext listexo
set types {    {{Fichiers aller}            {.alr}        }
			{{Fichiers texte}            {.txt}        }
		}

set categorie [tk_getOpenFile -filetypes $types -initialdir $Home -title [mc {Fichier :}] ]
if {$categorie ==""} {
set categorie "Aucun"
}
.w1.frame2.categorie configure -wraplength 180 -height 4 -text $categorie
set ext .conf
set f [open [file join $Homeconf reglages aller$ext] "w"]
puts $f $categorie
close $f
set strtext ""
set listexo {}
setlistexo [file join $categorie]

interface
if {[string first "\$t tag add bisque1" $strtext]!=-1} {
.w1.frameleft.l7 configure -text [lindex [lindex $listexo 0] 1]
} else {
.w1.frameleft.l7 configure -text [mc {Exercice 1}]
}
if {[string first "\$t tag add bisque2" $strtext]!=-1} {
.w1.frameleft.l8 configure -text [lindex [lindex $listexo 1] 1]
} else {
.w1.frameleft.l8 configure -text [mc {Exercice 2}]
}
if {[string first "\$t tag add bisque3" $strtext]!=-1} {
.w1.frameleft.l9 configure -text [lindex [lindex $listexo 2] 1]
} else {
.w1.frameleft.l9 configure -text [mc {Exercice 3}]
}
if {[string first "\$t tag add bisque4" $strtext]!=-1} {
.w1.frameleft.l10 configure -text [lindex [lindex $listexo 3] 1]
} else {
.w1.frameleft.l10 configure -text [mc {Exercice 4}]
}


}
###################################################################################"""





